
"""
Created on Thu Nov 20 14:53:07 2014

@author: Johannes
"""
#import PyQt4.QtGui
#from PyQt4.QtCore import *
#from PyQt4.QtGui import *
#from PySide.QtCore import *
#from PySide.QtGui import *

import sys
import codecs
from PyQt4 import QtCore, QtGui
import ctypes
import os
import show
from Text import Text
from Adresses import Adresses
from MyTableModel import MyTableModel
from Configuration import Configuration
 
    
class MainDialog(QtGui.QDialog , show.Ui_mainDialog):        
    def __init__(self, parent=None):
        super(MainDialog, self).__init__(parent)
        self.setupUi(self)
#general settings
        self.setWindowTitle("Latex Utility Tool")  
        
        
#self.connect(self.showButton, QtCore.SIGNAL("clicked()"), self.showMessageBox)
        self.connect(self.loadButton, QtCore.SIGNAL("clicked()"), self.loadFile)
        self.connect(self.saveButton, QtCore.SIGNAL("clicked()"), self.saveFile)
        self.connect(self.loadAdressButton, QtCore.SIGNAL("clicked()"), self.loadAdress)
        self.connect(self.runLatexButton, QtCore.SIGNAL("clicked()"), self.runLatex)        
        self.connect(self.pushButton_Smiley, QtCore.SIGNAL("clicked()"), self.runSmiley)    
#        self.connect(self.pushButton_SaveSettings, QtCore.SIGNAL("clicked()"), self.tab_2(self.saveSettings))
        self.saveSettings.clicked.connect(self.pushButton_SaveSettings)
        self.pushButton_Manual.clicked.connect(self.callManual)

#settings for tableView
#        mlist = [[float(10) for y in range(10)]]
#        waveform_header = ['Adress', 'Adress', 'Adress', 'Adress']
#        self.waveformModel = MyTableModel(self, mlist, waveform_header)
#        self.tableView_Adresses.setModel(self.waveformModel)
       
#Variablen
        self.formattedData =""
        self.text=''
        self.adresses=''
        self.adressesFormatted=''
        self.filenameSave =''
        self.filenameLoad =''
        #reads out the settings.ini
        config = Configuration.configReadout(self)
        if int(x=config['user']['columnnameline']) == 0:
            self.lineEdit_ColumnNameLine.setText('')
        else:
            value = int(x=config['user']['columnnameline']) 
            self.lineEdit_ColumnNameLine.setText(str(value)) 
        self.lineEdit_Separator.setText(config['user']['separator'])
        self.lineEdit_SalutationFemale.setText(config['user']['salutationfemale'])
        self.lineEdit_SalutationMale.setText(config['user']['salutationmale'])
        self.lineEdit_Gender.setText(config['user']['gender'])
        
    
    #def showMessageBox(self):
      #  QtGui.QMessageBox.information(self, "Hello!", "Hello there, " + self.nameEdit.text())
        
    def loadFile(self):
        #opens the fileDialog
                
        self.filenameLoad = QtGui.QFileDialog.getOpenFileName(self, 'Open File', '.')
        
        try:       
       #opens the fileContent utf-8 encoded
            with codecs.open(self.filenameLoad, 'r', 'utf-8') as fname:
                self.text = fname.read()
                #sets filepath into lineEdit
                self.lineEdit_LoadTextFilepath.setText(self.filenameLoad)
                #writes fileContent into Textbox
                self.loadedFileContent.setText(''.join(str(e) for e in self.text))
        except UnicodeError:
            ctypes.windll.user32.MessageBoxW(None, 'Bitte Datei in unicode utf-8 hinterlegen!', 'Dateikodierungsfehler', 0)
        
        fname.close()
        
    
    def saveFile(self):
        self.filenameSave = QtGui.QFileDialog.getExistingDirectory(self)
        
        self.lineEdit_SaveTextFilepath.setText(self.filenameSave)
        #fname = open(self.filenameSave, 'w')
        #text=''
#        fname.write(text)
#        fname.close()
    
    def loadAdress(self):
        #sets line of ColumnNames
        if self.lineEdit_ColumnNameLine.text() == '':
            self.columnNameLine = int(x=0)            
        else:
            self.columnNameLine = int(x=int(self.lineEdit_ColumnNameLine.text()))
            

        #opens the fileDialog
  
        filename = QtGui.QFileDialog.getOpenFileName(self, 'Open File', '.')
        
        try:        
            with codecs.open(filename, encoding='utf-8') as fname:
                self.adresses = fname.read()
                self.lineEdit_AdressesFilepath.setText(filename)
                data=Adresses(self.adresses, self.lineEdit_Separator.text())
                #self.formattedData = dataformatted.formattedAdresses()
                self.adresses=data.formattedAdresses()
                table_Model = MyTableModel(self, self.adresses[self.columnNameLine +1:], self.adresses[self.columnNameLine]) 
                #writes fileContent into Textbox
                self.tableView_Adresses.setModel(table_Model)
        except UnicodeError:
            ctypes.windll.user32.MessageBoxW(None, 'Bitte Datei in unicode utf-8 hinterlegen!', 'Dateikodierungsfehler', 0)
        
        #self.saveFileContent.setText(formattedText.textAdressInput())
        fname.close()
 
    
    def runLatex(self):
#############
#Salutations#
#############
        if self.lineEdit_SalutationFemale.text() == '':
            self.salutationFemale = 'Sehr geehrte Frau'
        else:
            self.salutationFemale = self.lineEdit_SalutationFemale.text()
            
        if self.lineEdit_SalutationMale.text() == '':
            self.salutationMale = 'Sehr geehrter Herr'
        else:
            self.salutationMale = self.lineEdit_SalutationMale.text()
##################
#GenderExpression#
##################
        gender = []
        if self.lineEdit_Gender.text() == '':
            for ch in self.adresses[int(self.columnNameLine)]:
                if 'Gender' in ch:
                    gender.append(ch)
        else:
            self.gender = self.lineEdit_Gender.text()
#            for gen in gender:
#                for ch in self.adresses[int(self.columnNameLine)]:
#                    if gen in ch:
#                        gender.append(ch)
            

        text=Text(self.text, self.adresses, self.columnNameLine, self.salutationFemale, self.salutationMale, self.gender)
        text = text.setAdressesInText()
        self.saveFileContent.setText(''.join(text))
        
        if self.filenameSave == '':
            self.filenameSave = os.getcwd()
            self.lineEdit_SaveTextFilepath.setText(self.filenameSave)
        i = self.columnNameLine+1
        for x in text:
            
                filename = self.filenameSave + '\\' + self.adresses[i][0] + self.adresses[i][1] + ".tex"
                fname = codecs.open(filename, 'w', encoding='utf-8')
                fname.write(x)            
                fname.close()
                os.chdir(self.filenameSave)
                os.system("pdflatex " + self.adresses[i][0] + self.adresses[i][1])
                #subprocess.call("pdflatex " + self.adresses[i][0] + self.adresses[i][1], shell=True)
                            
                if self.checkBox_pdfDisplay.isChecked():
                    os.startfile(self.adresses[i][0] + self.adresses[i][1] + ".pdf")
                
                i+=1
        
                
    def runSmiley(self):
        i=0
        text = self.text
        textdata = text
        data = ''
        for x in range(0,len(self.text)):
            try:
                if text[x] + text[x+1] == '**' or i == 1:
                    data += text[x]
                    if text[x] + text[x+1] == '**':
                        i += 1
                        if i == 2:
                            data += text[x+1]
                            textdata = textdata.replace(data, '\\xblackout{' + int(len(data) / 3) * 't t' + '}')
                            i=0
                            data = ''
            except:
                if text[x] == '*':
                    data += text[x]
                    textdata = textdata.replace(data, '\\xblackout{' + int(len(data) / 3) * 't t' + '}') 
                    i = 0
                    data = ''
                break
                
        filename =   self.filenameLoad
        fname = codecs.open(filename, 'w', encoding='utf-8')
        fname.write(textdata)            
        fname.close()
        
    def pushButton_SaveSettings(self):
        if self.lineEdit_ColumnNameLine.text() == (0 or ''):
            self.columnNameLine = 0           
        else:
            self.columnNameLine = int(x=int(self.lineEdit_ColumnNameLine.text()))
       
        settings= Configuration(self.columnNameLine, self.lineEdit_Separator.text(), self.lineEdit_SalutationFemale.text(), self.lineEdit_SalutationMale.text(), self.lineEdit_Gender.text())
        settings.configWrite()
               
    def callManual(self):
                
        os.startfile("Manual.pdf")
        
        
        
app = QtGui.QApplication(sys.argv)

form = MainDialog()
form.show()
app.exec_()